 @program prog_code,prog_name

GetKey MACRO
  move.w  \1,($600018)
  nop
  nop
  nop
  nop
  move.b  ($60001B),d0
 ENDM

prog_code:
 move.w  #$2700,sr		  ; Disable interrupts
 jsr flib[clr_scr]		  ; Clear screen

 move.l  #$F00,-(a7)		  ; Create a virtual screen
 jsr	 romlib[create_handle]	  ; It should be the same size as the
 lea	 4(a7),a7		  ; video memory
 move.w  d0,vscr_h		  ; Store the handle number in vscr_h
 handle_ptr d0,a6		  ; Find out where in the RAM the vscr is
 adda	 #900,a6		  ; We won't use the first 900 bytes
 move.l  a6,vscr		  ; Store the address to the virt scr at vscr
 clr.w	 frames 		  ; Clear the frame counter

 move.l  #680,d0		  ; Clear the virtual screen
RepClrV:
 clr.l	 (a6)+			  ; Only the middle of it though,
 dbra	 d0,RepClrV		  ; 680 longwords

 move.w  #2,-(a7)		  ; Write all text
 jsr romlib[set_font]
 move.w  #4,-(a7)
 pea	 progInfo(PC)
 move.l  #$200008,-(a7)
 jsr romlib[puttext]
 move.w  #1,-(a7)
 jsr romlib[set_font]
 move.w  #4,-(a7)
 pea	 author(PC)
 move.l  #$120014,-(a7)
 jsr romlib[puttext]
 clr.w	 -(a7)
 jsr romlib[set_font]
 move.w  #4,-(a7)
 pea	 modeText(PC)
 move.l  #$03007B,-(a7)
 jsr romlib[puttext]
 move.w  #4,-(a7)
 pea	 ctrlInfo(PC)
 move.l  #$48007B,-(a7)
 jsr romlib[puttext]
 lea	 46(a7),a7

 move.l  #$19202200,vx		  ; Set start angels + dispmove
 move.w  #$0001,modecnt 	  ; Set mode and counter

ChangeMode:
 tst.b	 (modecnt)
 bne RepRotate
 lea	 modes(PC),a0
 bchg.b  #0,control
 bne NoAdd
 adda	 #5,a0
NoAdd:
 move.b  #5,modecnt
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.l  #$1A007B,-(a7)
 jsr romlib[puttext]
 lea	 10(a7),a7
RepRotate:
 jsr Calc3D
 jsr DrawTorus
 tst.b	 modecnt
 beq NoCntDec
 subq.b  #1,modecnt
NoCntDec:
 tst.b	 (control)
 bne Manual
 addq.b  #4,vx
 addq.b  #5,vy
 addq.b  #6,vz
 bra IncFrame
Manual:
 GetKey  #$FFFD
 btst	 #5,d0
 bne Chk2
 subq.b  #5,vx
Chk2:
 btst	 #6,d0
 bne Chk3
 subq.b  #5,vy
Chk3:
 btst	 #7,d0
 bne Chk4
 subq.b  #5,vz
Chk4:
 GetKey  #$FFFB
 btst	 #5,d0
 bne Chk5
 addq.b  #5,vx
Chk5:
 btst	 #6,d0
 bne Chk6
 addq.b  #5,vy
Chk6:
 btst	 #7,d0
 bne IncFrame
 addq.b  #5,vz
IncFrame:
 addq.w  #1,frames
 clr.l	 d0
 move.w  frames,d0
 lea	 strend(PC),a0
 clr.b	 -(a0)
 moveq	 #4,d1
RepConv:
 divu	 #10,d0
 move.l  d0,d2
 swap	 d2
 add.b	 #48,d2
 move.b  d2,-(a0)
 and.l	 #$FFFF,d0
 dbra	 d1,RepConv
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #123,-(a7)
 move.w  #218,-(a7)
 jsr romlib[puttext]
 lea	 10(a7),a7

 GetKey  #$FEFF
 btst	 #4,d0
 beq SwitchDispMode
 btst	 #5,d0
 beq ChangeMode
 btst	 #6,d0
 bne RepRotate

 move.w  vscr_h(pc),-(a7)
 jsr	 romlib[destroy_handle]
 lea	 2(a7),a7
 jsr flib[idle_loop]
 move.w  #$2000,sr
 rts

SwitchDispMode:
 tst.b	 (modecnt)
 bne RepRotate
 bchg.b  #0,dispmode
 move.b  #5,modecnt
 bra RepRotate

DrawTorus:
 move.l  vscr,a0
 move.l  #680,d0
RepClr:
 clr.l	 (a0)+
 dbra	 d0,RepClr
 move.l  vscr,a0
 lea	 dotc(PC),a1
 tst.b	 (dispmode)
 bne DrawPoints
 lea	 lines(PC),a2
 move.l  #nolines,d7
RepDrawLines:
 clr.l	 d5
 clr.l	 d6
 move.b  (a2)+,d5
 move.b  (a2)+,d6
 lsl.w	 #2,d5
 lsl.w	 #2,d6
 move.w  0(a1,d5),d0
 move.w  2(a1,d5),d1
 move.w  0(a1,d6),d2
 move.w  2(a1,d6),d3
 jsr linelib[fline]
 dbra	 d7,RepDrawLines
 bra Flip
DrawPoints:
 move.l  #nopoints,d7
RepDrawPoints:
 move.w  (a1)+,d0
 move.w  (a1)+,d1
 move.w  d1,d4
 move.w  d1,d5
 lsl.w	 #5,d4
 lsl.w	 #1,d5
 sub.w	 d5,d4
 move.w  d0,d5
 lsr.w	 #3,d5
 add.w	 d5,d4
 move.w  d0,d5
 not	 d5
 and.b	 #$07,d5
 bset.b  d5,0(a0,d4)
 dbra	 d7,RepDrawPoints
Flip:
 lea	 $47C4,a1
 move.l  #680,d0
RepVCopy:
 move.l  (a0)+,(a1)+
 dbra	 d0,RepVCopy
 rts

Calc3D:
 lea	 points(PC),a0
 lea	 sintable+$80(PC),a1
 lea	 sintable(PC),a2
 lea	 dotc(PC),a6
 move.l  #nopoints,d7
RepPoints:
 move.l  d7,-(a7)
 move.w  (a0)+,d0
 ext.l	 d0
 move.w  (a0)+,d1
 ext.l	 d1
 move.w  (a0)+,d2
 ext.l	 d2

 clr.l	 d3
 move.b  vy,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   ; d4=yc
 move.w  0(a2,d3),d5   ; d5=ys
 ext.l	 d4
 ext.l	 d5

 move.l  d0,d6
 muls	 d4,d6	       ; d6=x*yc
 move.l  d2,d7
 muls	 d5,d7	       ; d7=ys*z
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l	 #4,d6
 move.l  d6,a3	       ; a3=(yc*x-ys*z)/factor (xt)
 move.l  d0,d6
 muls	 d5,d6
 move.l  d2,d7
 muls	 d4,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,a4	       ; a4=(ys*x+yc*z)/factor (zt)

 clr.l	 d3
 move.b  vz,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   ; d4=zc
 move.w  0(a2,d3),d5   ; d5=zs

 move.l  a3,d6
 muls	 d4,d6
 move.l  d1,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,d0	       ; d0=(zc*xt+zs*y) DIV faktor (x)
 move.l  d1,d6
 muls	 d4,d6
 move.l  a3,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l	 #4,d6
 move.w  d6,a5	       ; a5=(zc*y-zs*xt) DIV faktor (yt)

 clr.l	 d3
 move.b  vx,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   ; d4=xc
 move.w  0(a2,d3),d5   ; d5=xs

 move.l  a4,d6
 muls	 d4,d6
 move.l  a5,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l	 #4,d6
 move.l  d6,d2	       ; d2=(xc*zt-xs*yt) DIV faktor (z)
 move.l  a5,d6
 muls	 d4,d6
 move.l  a4,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,d1	       ; d1=(xs*zt+xc*yt) DIV faktor (y)

 sub.w	 #1024,d2
 beq DivZero
 lsl.l	 #8,d0
 lsl.l	 #2,d0
 move.l  d0,d4
 divs	 d2,d4
 ext.l	 d4
 add.l	 #120,d4
 lsl.l	 #8,d1
 lsl.l	 #2,d1
 move.l  d1,d5
 divs	 d2,d5
 ext.l	 d5
 add.l	 #44,d5
 bra PutPoint
DivZero:
 move.l  #120,d4
 move.l  #44,d5
PutPoint:
 move.w  d4,(a6)+
 move.w  d5,(a6)+
 move.l  (a7)+,d7
 dbra	 d7,RepPoints
 rts

sintable:
 incbin "sint.bin"

points:
 incbin "t_points.bin"

lines:
 incbin "t_lines.bin"

nopoints    = 179
nolines     = 358

dotc	 ds.l nopoints+1

vscr_h	 dc.w 0
vscr	 dc.l 0

frames	 dc.w 0

str	 ds.b 6
strend

vx	 dc.b 0
vy	 dc.b 0
vz	 dc.b 0
dispmode dc.b 0

modecnt  dc.b 0
control  dc.b 0

progInfo dc.b "*** TORUS DEMO 1.1 ***",0
author	 dc.b "by Jimmy M",229,"rdell  <mja@algonet.se>",0

modeText dc.b "MODE:",0
modes	 dc.b "Demo",0,"User   ",0

ctrlInfo dc.b "Keys: [MODE], [ESC], [1]-[6], [+]",0

prog_name:
 dc.b "Torus",0

 reloc_open
 add_library flib
 add_library romlib
 add_library linelib
 reloc_close
 end
